Index: sandbox/workflow/trunk/inc/class.bo_adminsource.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.bo_adminsource.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.bo_adminsource.inc.php	(revision 2372)
@@ -11,9 +11,4 @@
 
 require_once('class.bo_ajaxinterface.inc.php');
-
-require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'ProcessManager' . SEP . 'ProcessManager.php');
-require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'ProcessManager' . SEP . 'RoleManager.php');
-require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'ProcessManager' . SEP . 'ActivityManager.php');
-require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'API' . SEP . 'Process.php');
 
 /**
@@ -80,5 +75,5 @@
 		$fileSizeUnit[] = 'Mb';
 		$fileSizeUnit[] = 'Gb';
-		
+
 		$unitSelect = 0;
 		while ($value > 1024.0)
@@ -87,26 +82,26 @@
 			$unitSelect++;
 		}
-	
+
 		$output = round($value, 1);
 		$output .= " " . $fileSizeUnit[$unitSelect];
-	
+
 		return $output;
 	}
-	
+
 	/**
 	* Get process toolbar data
-	* @param  array $p process process data 
-	* @return array
-	* @access public 
-	*/	
-	function get_toolbar_data($p) 
-	{
-		
-		$process_manager = new ProcessManager($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
-		$proc_info       = $process_manager->get_process($p['proc_id']); 
-		
+	* @param  array $p process process data
+	* @return array
+	* @access public
+	*/
+	function get_toolbar_data($p)
+	{
+
+		$process_manager = &Factory::newInstance('ProcessManager');
+		$proc_info       = $process_manager->get_process($p['proc_id']);
+
 		$web_server_url  = $_SESSION['phpgw_info']['workflow']['server']['webserver_url'];
-		$img_default_dir = $GLOBALS['workflow']['factory']->getInstance('TemplateServer')->generateImageLink('');
-		
+		$img_default_dir = Factory::getInstance('TemplateServer')->generateImageLink('');
+
 		if ($proc_info['wf_is_valid'] == 'y')
 		{
@@ -119,5 +114,5 @@
 			$alt_validity = tra('invalid');
 		}
-	
+
 		// if process is active show stop button. Else show start button, but only if it is valid. If it's not valid, don't show any activation or stop button.
 		if ($proc_info['wf_is_active'] == 'y')
@@ -138,5 +133,5 @@
 			$start_stop_img  = '';
 		}
-	
+
 		/* load other processes link */
 		$proc_ids = $GLOBALS['ajax']->acl->get_granted_processes($_SESSION['phpgw_info']['workflow']['account_id']);
@@ -145,10 +140,10 @@
 		else
 			$where = ' wf_p_id = -1 ';
-	
+
 		$processesInfo = &$process_manager->list_processes(0, -1, 'wf_name__asc', '', $where);
 		$otherProcesses = array();
 		foreach ($processesInfo['data'] as $pi)
 			$otherProcesses[] = array("name" => $pi['wf_name'] . " (v" . $pi['wf_version'] . ")", "link" => $web_server_url . "/index.php?menuaction=workflow.ui_adminsource.form&p_id=" . $pi['wf_p_id'], "pid" => $pi['wf_p_id']);
-	
+
 		$toolbar_data = array (
 			'proc_name'					=> $proc_info['wf_name'],
@@ -177,18 +172,18 @@
 			'other_processes'			=> $otherProcesses
 		);
-			
+
 		return $toolbar_data;
 		}
-		
-		
+
+
 	/**
 	* Get process model files
-	* @param  array $p process process data 
-	* @return array
-	* @access public 
+	* @param  array $p process process data
+	* @return array
+	* @access public
 	*/
 	function get_model_files($p)
 	{
-		switch($p['type']) 
+		switch($p['type'])
 		{
 			case 'include'  : $path = PHPGW_SERVER_ROOT . SEP . 'workflow' . SEP . 'js' . SEP . 'adminsource' . SEP . 'inc';
@@ -203,9 +198,9 @@
 		$files          = array();
 
-		if ($handle = opendir($path)) 
-		{
-			while (false !== ($file_name = readdir($handle))) 
-			{	
-				if (!is_dir($path.SEP.$file_name)) 
+		if ($handle = opendir($path))
+		{
+			while (false !== ($file_name = readdir($handle)))
+			{
+				if (!is_dir($path.SEP.$file_name))
 				{
 					$files[] = array('file_name'     => $file_name);
@@ -217,21 +212,21 @@
 		array_multisort($col_file_name,SORT_ASC,$files);
 
-		return $files; 
+		return $files;
 	}
 
 	/**
 	* Get process php files
-	* @param array $p process data 
-	* @return array
-	* @access public 
+	* @param array $p process data
+	* @return array
+	* @access public
 	*/
 	function get_php_files($p)
 	{
-		$process_manager    = new ProcessManager($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+		$process_manager    = &Factory::newInstance('ProcessManager');
 		$proc_info          = $process_manager->get_process($p['proc_id']);
-		$activity_manager   = new ActivityManager($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+		$activity_manager   = &Factory::newInstance('ActivityManager');
 		$process_activities = $activity_manager->list_activities($p['proc_id'], 0, -1, 'wf_name__asc', '','',false);
 		$path = GALAXIA_PROCESSES . SEP . $proc_info['wf_normalized_name'] . SEP . 'code' . SEP .'activities' . SEP;
-		
+
 		$files = array();
 
@@ -242,10 +237,10 @@
 		foreach ($process_activities['data'] as $process_activity)
 		{
-			
+
 			$file_name   = $process_activity['wf_normalized_name'].'.php';
 			$activity_id = $process_activity['wf_activity_id'];
 			$tamanho     = filesize($path.$file_name);
 			$modificado  = date('d/m/Y H:i:s', filemtime($path.$file_name) );
-			
+
 			$files[] = array('file_name'     => $file_name,
 							 'activity_id'   => $activity_id,
@@ -258,11 +253,11 @@
 							 'tipo_codigo'   => 'atividade'
 			);
-			
+
 			$col_file_name[]  = $file_name;
 			$col_tamanho[]    = $tamanho;
 			$col_modificado[] = $modificado;
 		}
-		
-		if (isset($p['sort'])) 
+
+		if (isset($p['sort']))
 		{
 			$order_by = ($p['order_by'] == 1) ? SORT_ASC : SORT_DESC;
@@ -279,13 +274,13 @@
 			}
 		}
-		
-		return $files; 
-	}
-	
-	/**
-	* Delete process file 
+
+		return $files;
+	}
+
+	/**
+	* Delete process file
 	* @param array $p process data
 	* @return array
-	* @access public 
+	* @access public
 	*/
 	function delete_file($p)
@@ -293,12 +288,12 @@
 		if ((strpos($p['file_name'],'/') !== false) || (strpos($p['file_name'],'/') !== false))
 			return 'Não foi possível executar a operação solicitada';
-		$process_manager = new ProcessManager($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
-		$proc_info = $process_manager->get_process($p['proc_id']); 
+		$process_manager = &Factory::newInstance('ProcessManager');
+		$proc_info = $process_manager->get_process($p['proc_id']);
 		$file_name = $p['file_name'];
-		$proc_name = $proc_info['wf_normalized_name']; 
+		$proc_name = $proc_info['wf_normalized_name'];
 		$type      = $p['type'];
 		if (strpos($file_name,'/')) return 'Nome de arquivo inválido.';
 		if (!strlen($proc_name)) return 'ID de Processo inválido.';
-		
+
     switch($type)
     {
@@ -315,17 +310,17 @@
 				$path = GALAXIA_PROCESSES . '/' . $proc_info['wf_normalized_name'] . '/resources/' . $file_name;
             break;
-			
+
     }
-   
-	   	if ($type == 'resource') 
+
+	   	if ($type == 'resource')
 		{
 			$complete_path = $path;
-		} 
-		else 
+		}
+		else
 		{
 			$complete_path = GALAXIA_PROCESSES . SEP . $proc_name . SEP . 'code' . SEP . $path;
 		}
-	
-		if (file_exists($complete_path)) 
+
+		if (file_exists($complete_path))
 		{
 			if (unlink($complete_path))
@@ -342,17 +337,17 @@
 			return 'O arquivo '.$file_name.' não existe.';
 		}
-	}	
-	/**
-	* Create process new file 
+	}
+	/**
+	* Create process new file
 	* @param array $p process
 	* @return array
-	* @access public 
+	* @access public
 	*/
 	function create_file($p)
 	{
-		$process_manager = new ProcessManager($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
-		$proc_info = $process_manager->get_process($p['proc_id']); 
+		$process_manager = &Factory::newInstance('ProcessManager');
+		$proc_info = $process_manager->get_process($p['proc_id']);
 		$file_name = $p['file_name'];
-		$proc_name = $proc_info['wf_normalized_name']; 
+		$proc_name = $proc_info['wf_normalized_name'];
 		$type      = $p['type'];
 
@@ -386,7 +381,7 @@
 		}
 
-		if (file_exists($complete_path)) 
-		{
-			if (!$p['rewrite']) 
+		if (file_exists($complete_path))
+		{
+			if (!$p['rewrite'])
 			{
 				return FILE_ALREADY_EXISTS;
@@ -396,5 +391,5 @@
 		}
 
-		if ($fp = fopen($complete_path, 'w')) 
+		if ($fp = fopen($complete_path, 'w'))
 		{
 			$basepath = PHPGW_SERVER_ROOT.SEP.'workflow'.SEP.'js'.SEP.'adminsource';
@@ -409,5 +404,5 @@
 			if ($type == 'template' || $type == 'include')
 			{
-				if (file_exists($basepath.SEP.$p['modelo'])) 
+				if (file_exists($basepath.SEP.$p['modelo']))
 				{
 					fwrite($fp,file_get_contents($basepath.SEP.$p['modelo']));
@@ -423,15 +418,15 @@
 		}
 	}
-	
+
 	/**
 	* Get process include files
 	* @param  array $p process
 	* @return array
-	* @access public 
+	* @access public
 	*/
 	function get_include_files($p)
 	{
-		$process_manager    = new ProcessManager($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
-		$proc_info          = $process_manager->get_process($p['proc_id']); 
+		$process_manager    = &Factory::newInstance('ProcessManager');
+		$proc_info          = $process_manager->get_process($p['proc_id']);
 		$path = GALAXIA_PROCESSES . SEP . $proc_info['wf_normalized_name'] . SEP . 'code';
 
@@ -442,9 +437,9 @@
 		$files          = array();
 
-		if ($handle = opendir($path)) 
-		{
-			while (false !== ($file_name = readdir($handle))) 
-			{	
-				if (!is_dir($path.SEP.$file_name)) 
+		if ($handle = opendir($path))
+		{
+			while (false !== ($file_name = readdir($handle)))
+			{
+				if (!is_dir($path.SEP.$file_name))
 				{
 					$tamanho     = filesize($path.SEP.$file_name);
@@ -467,5 +462,5 @@
 
 
-		if (isset($p['sort'])) 
+		if (isset($p['sort']))
 		{
 			$order_by = ($p['order_by'] == 1) ? SORT_ASC : SORT_DESC;
@@ -483,17 +478,17 @@
 		}
 
-		return $files; 
-	}
-
-	/**
-	* Get process template files 
-	* @param array $p process data 
-	* @return array
-	* @access public 
+		return $files;
+	}
+
+	/**
+	* Get process template files
+	* @param array $p process data
+	* @return array
+	* @access public
 	*/
 	function get_template_files($p)
 	{
-		$process_manager    = new ProcessManager($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
-		$proc_info          = $process_manager->get_process($p['proc_id']); 
+		$process_manager    = &Factory::newInstance('ProcessManager');
+		$proc_info          = $process_manager->get_process($p['proc_id']);
 		$path = GALAXIA_PROCESSES . SEP . $proc_info['wf_normalized_name'] . SEP . 'code' . SEP .'templates';
 
@@ -502,9 +497,9 @@
 		$col_modificado = array();
 
-		if ($handle = opendir($path)) 
-		{
-			while (false !== ($file_name = readdir($handle))) 
-			{	
-				if (!is_dir($path.SEP.$file_name)) 
+		if ($handle = opendir($path))
+		{
+			while (false !== ($file_name = readdir($handle)))
+			{
+				if (!is_dir($path.SEP.$file_name))
 				{
 					$tamanho     = filesize($path.SEP.$file_name);
@@ -541,19 +536,19 @@
 
         }
-    }	
-
-		return $files; 
-	}
-
-	/**
-	* Upload process resource  
-	* 
+    }
+
+		return $files;
+	}
+
+	/**
+	* Upload process resource
+	*
 	* @param array $p process
 	* @return array
-	* @access public 
+	* @access public
 	*/
 	function upload_resource($p)
 	{
-		$process_manager = new ProcessManager($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+		$process_manager = &Factory::newInstance('ProcessManager');
 		$proc_info = $process_manager->get_process($p['proc_id']);
 		$file_name = basename($_FILES['resource_file']['name']);
@@ -587,5 +582,5 @@
 		if (strpos($_REQUEST['file_name'],'/') !== false)
 			return 'Não foi possível executar a operação solicitada';
-		$process_manager    = new ProcessManager($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+		$process_manager    = &Factory::newInstance('ProcessManager');
 		$proc_info          = $process_manager->get_process($_REQUEST['proc_id']);
 
@@ -617,5 +612,5 @@
 			$completePath = GALAXIA_PROCESSES . SEP . $proc_name . SEP . 'code' . SEP . $path;
 
-		$GLOBALS['workflow']['factory']->getInstance('ResourcesRedirector')->show($completePath, 'application/force-download');
+		Factory::getInstance('ResourcesRedirector')->show($completePath, 'application/force-download');
 		exit;
 	}
@@ -630,5 +625,5 @@
 	function get_resource_files($p)
 	{
-		$process_manager    = new ProcessManager($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+		$process_manager    = &Factory::newInstance('ProcessManager');
 		$proc_info          = $process_manager->get_process($p['proc_id']);
 
Index: sandbox/workflow/trunk/inc/class.bo_orgchart.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.bo_orgchart.inc.php	(revision 2042)
+++ sandbox/workflow/trunk/inc/class.bo_orgchart.inc.php	(revision 2372)
@@ -10,5 +10,4 @@
 \**************************************************************************/
 
-require_once('class.so_orgchart.inc.php');
 require_once('class.bo_ajaxinterface.inc.php');
 /**
@@ -47,5 +46,5 @@
 	{
 		parent::bo_ajaxinterface();
-		$this->so = new so_orgchart();
+		$this->so = &Factory::getInstance('so_orgchart');
 	}
 
Index: sandbox/workflow/trunk/inc/class.workflow_instancemanager.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.workflow_instancemanager.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.workflow_instancemanager.inc.php	(revision 2372)
@@ -17,5 +17,5 @@
 		function workflow_instancemanager()
 		{
-			parent::InstanceManager($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+			parent::InstanceManager(Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID);
 		}
 	}
Index: sandbox/workflow/trunk/inc/nano/NanoGuardian.class.php
===================================================================
--- sandbox/workflow/trunk/inc/nano/NanoGuardian.class.php	(revision 795)
+++ sandbox/workflow/trunk/inc/nano/NanoGuardian.class.php	(revision 2372)
@@ -32,5 +32,5 @@
     public function __construct()
     {
-        $this->_mObjNanoSanitizer = new NanoSanitizer(new DummyLogger);
+        $this->_mObjNanoSanitizer = &Factory::newInstance('NanoSanitizer', new DummyLogger);
     }
 
Index: sandbox/workflow/trunk/inc/nano/NanoJsonConverter.class.php
===================================================================
--- sandbox/workflow/trunk/inc/nano/NanoJsonConverter.class.php	(revision 795)
+++ sandbox/workflow/trunk/inc/nano/NanoJsonConverter.class.php	(revision 2372)
@@ -118,6 +118,6 @@
         // initialize JSON object
         $this->_mObjJson = ( strtolower($return_type) != 'object' )
-                                ? new Services_JSON( SERVICES_JSON_LOOSE_TYPE )
-                                : new Services_JSON();
+                                ? Factory::getInstance('Services_JSON', SERVICES_JSON_LOOSE_TYPE )
+                                : Factory::getInstance('Services_JSON');
     }
 
Index: sandbox/workflow/trunk/inc/nano/NanoController.class.php
===================================================================
--- sandbox/workflow/trunk/inc/nano/NanoController.class.php	(revision 795)
+++ sandbox/workflow/trunk/inc/nano/NanoController.class.php	(revision 2372)
@@ -59,6 +59,6 @@
     function __construct()
     {
-        $this->_mObjJsonConverter = new NanoJsonConverter();
-        $this->_mObjJson          = new Services_JSON();
+        $this->_mObjJsonConverter = &Factory::newInstance('NanoJsonConverter');
+        $this->_mObjJson          = &Factory::newInstance('Services_JSON');
     }
 
@@ -130,5 +130,5 @@
     public function iterateOverVirtualRequests()
     {
-        $this->_mObjNanoRequest = new NanoRequest( $this->_mStrClassPath, $this->_mStrClassSuffix, $this->_mStrClassPreffix );
+        $this->_mObjNanoRequest = &Factory::newInstance('NanoRequest', $this->_mStrClassPath, $this->_mStrClassSuffix, $this->_mStrClassPreffix );
         $return_data            = array();
 
Index: sandbox/workflow/trunk/inc/class.bo_monitors.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.bo_monitors.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.bo_monitors.inc.php	(revision 2372)
@@ -12,14 +12,10 @@
 require_once('class.bo_ajaxinterface.inc.php');
 
-require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'GUI' . SEP . 'GUI.php');
-require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'ProcessManager' . SEP . 'ProcessManager.php');
-require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'ProcessManager' . SEP . 'ActivityManager.php');
-require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'ProcessManager' . SEP . 'InstanceManager.php');
-require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'ProcessManager' . SEP . 'RoleManager.php');
-require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'ProcessMonitor' . SEP . 'ProcessMonitor.php');
-require_once(GALAXIA_LIBRARY . SEP . 'src' . SEP . 'API' . SEP . 'Instance.php');
-require_once('class.workflow_acl.inc.php');
-require_once('class.bo_adminaccess.inc.php');
-require_once('class.powergraphic.inc.php');
+
+/**
+ * DO NOT remove this line. Ever. Somehow, monitors interface will stop working..
+ */
+require_once(PHPGW_API_INC . SEP . 'common_functions.inc.php');
+
 
 /**
@@ -134,12 +130,12 @@
 	{
 		parent::bo_ajaxinterface();
-		$GLOBALS['ajax']->gui   = new GUI($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+		$GLOBALS['ajax']->gui   = &Factory::newInstance('GUI');
 		$this->userID 			= $_SESSION['phpgw_info']['workflow']['account_id'];
 		$this->isWorkflowAdmin  = $GLOBALS['ajax']->acl->checkWorkflowAdmin($this->userID);
-		$this->processManager   = new ProcessManager($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
-		$this->activityManager  = new ActivityManager($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
-		$this->instanceManager  = new InstanceManager($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
-		$this->roleManager 		= new RoleManager($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
-		$this->processMonitor   = new ProcessMonitor($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+		$this->processManager   = &Factory::newInstance('ProcessManager');
+		$this->activityManager  = &Factory::newInstance('ActivityManager');
+		$this->instanceManager  = &Factory::newInstance('InstanceManager');
+		$this->roleManager 		= &Factory::newInstance('RoleManager');
+		$this->processMonitor   = &Factory::newInstance('ProcessMonitor');
 	}
 
@@ -169,8 +165,7 @@
 	private function convertFiltersToSQL($filters)
 	{
-		require_once 'nano/JSON.php';
 
 		/* desserializa os dados */
-		$JSON = new Services_JSON();
+		$JSON = &Factory::newInstance('Services_JSON');
 		/* desserializa a array principal, depois desserializa cada elemento desta array e, por fim, converte os elementos (que estão em forma de objeto) para array associativa */
 		$filters = array_map('get_object_vars', array_map(array($JSON, 'decode'), $JSON->decode($filters)));
@@ -335,8 +330,8 @@
 	   	$filters[] = '(gia.wf_user IS NOT NULL)';
 
-		$ldap = &$GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP');
+		$ldap = &Factory::getInstance('WorkflowLDAP');
 		if (!$completeData)
 		{
-			$paging = $GLOBALS['workflow']['factory']->newInstance('Paging', 500, $_POST);
+			$paging = Factory::newInstance('Paging', 500, $_POST);
 			$tmp = $this->processMonitor->monitor_list_instances($paging->nextItem, $paging->itemsPerPage, $order, '', implode(' AND ', $filters));
 			$output['data'] = $paging->restrictItems(array_values($tmp['data']), $tmp['cant']);
@@ -353,5 +348,5 @@
 		$activityMapping = array();
 		$instanceCount = count($output['data']);
-		$cachedLDAP = &$GLOBALS['workflow']['factory']->getInstance('CachedLDAP');
+		$cachedLDAP = &Factory::getInstance('CachedLDAP');
 		for ($i = 0; $i < $instanceCount; $i++)
 		{
@@ -476,8 +471,8 @@
 		/* load the data */
 		$filters[] = '(gp.wf_p_id = ' . $params['pid'] . ')';
-		$ldap = &$GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP');
+		$ldap = &Factory::getInstance('WorkflowLDAP');
 		if (!$completeData)
 		{
-			$paging = $GLOBALS['workflow']['factory']->newInstance('Paging', 500, $_POST);
+			$paging = Factory::newInstance('Paging', 500, $_POST);
 			$tmp = $this->processMonitor->monitor_list_completed_instances($paging->nextItem, $paging->itemsPerPage, $order, '', implode(' AND ', $filters));
 			$output['data'] = $paging->restrictItems(array_values($tmp['data']), $tmp['cant']);
@@ -491,5 +486,5 @@
 		}
 
-		$cachedLDAP = &$GLOBALS['workflow']['factory']->getInstance('CachedLDAP');
+		$cachedLDAP = &Factory::getInstance('CachedLDAP');
 		$userMapping = array();
 		$instanceCount = count($output['data']);
@@ -627,5 +622,5 @@
 			}
 			else
-				$output['fullname'] = $GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP')->getName($user);
+				$output['fullname'] = Factory::getInstance('WorkflowLDAP')->getName($user);
 
 		$this->instanceManager->set_instance_user($params['iid'], $params['aid'], $user);
@@ -648,5 +643,5 @@
 		if ($params['ns'] == 'aborted')
 		{
-			$realInstance = new Instance($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+			$realInstance = &Factory::newInstance('Instance');
 			$realInstance->getInstance($params['iid']);
 			if (!empty($realInstance->instanceId))
@@ -684,5 +679,5 @@
 
 		/* use next user or * for the new instance */
-		$realInstance = new Instance($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+		$realInstance = &Factory::newInstance('Instance');
 		$realInstance->getInstance($params['iid'], false, false);
 		$user = $realInstance->getNextUser($params['aid']);
@@ -751,5 +746,5 @@
 
 		$maximumDisplaySize = 100;
-		$instance = new Instance($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+		$instance = &Factory::newInstance('Instance');
 		$instance->getInstance($params['iid']);
 
@@ -783,5 +778,5 @@
 			return "Você não tem permissão para executar este procedimento!";
 
-		$instance = new Instance($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+		$instance = &Factory::newInstance('Instance');
 		$instance->getInstance($params['iid']);
 		$output = $params;
@@ -804,5 +799,5 @@
 		$maximumDisplaySize = 100;
 
-		$instance = new Instance($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+		$instance = &Factory::newInstance('Instance');
 		$instance->getInstance($params['iid']);
 		$instance->set($params['name'], $params['value']);
@@ -835,5 +830,5 @@
 			return "Você não tem permissão para executar este procedimento!";
 
-		$instance = new Instance($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+		$instance = &Factory::newInstance('Instance');
 		$instance->getInstance($params['iid']);
 		$instance->clear($params['name']);
@@ -858,5 +853,5 @@
 		$output = array();
 		$urlPrefix = 'workflow/inc/class.powergraphic.inc.php?';
-		$powergraphic = new powergraphic;
+		$powergraphic = &Factory::getInstance('powergraphic');
 		$powergraphic->graphic_1 = $params['pid'];
 		$powergraphic->skin = 1;
@@ -904,5 +899,5 @@
 		/* prepare the data */
 		$aux2 = array();
-		$ldap = &$GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP');
+		$ldap = &Factory::getInstance('WorkflowLDAP');
 		foreach ($aux as $user => $count)
 			$aux2[] = array(
@@ -984,5 +979,5 @@
 
 		/* load LDAP info and sort the result */
-		$foundUsers = $GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP')->getNames($users);
+		$foundUsers = Factory::getInstance('WorkflowLDAP')->getNames($users);
 		usort($foundUsers, create_function('$a,$b', 'return strcasecmp($a[\'name\'],$b[\'name\']);'));
 
@@ -991,5 +986,5 @@
 		if (count($users) > count($foundUsers))
 		{
-			$cachedLDAP = &$GLOBALS['workflow']['factory']->getInstance('CachedLDAP');
+			$cachedLDAP = &Factory::getInstance('CachedLDAP');
 			$foundUsersID = array_map(create_function('$a', 'return $a[\'id\'];'), $foundUsers);
 			$missingUsers = array_diff($users, $foundUsersID);
@@ -1242,5 +1237,5 @@
 			return $output;
 
-		$BOUserInterface = &$GLOBALS['workflow']['factory']->getInstance('bo_userinterface');
+		$BOUserInterface = &Factory::getInstance('bo_userinterface');
 
 		/* initialize some variables */
@@ -1344,5 +1339,5 @@
 
 		/* load the recipient e-mail */
-		$ldap = &$GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP');
+		$ldap = &Factory::getInstance('WorkflowLDAP');
 		foreach ($output as $key => $value)
 		{
@@ -1396,13 +1391,23 @@
 
 		/* prepare the environment to load some configuration values from other module */
-		$GLOBALS['phpgw']->db = &$GLOBALS['workflow']['workflowObjects']->getDBExpresso();
-		$GLOBALS['phpgw']->common = CreateObject('phpgwapi.common');
-		$GLOBALS['phpgw']->session = CreateObject('phpgwapi.sessions');
+		$GLOBALS['phpgw']->db =& Factory::getInstance('WorkflowObjects')->getDBExpresso();
+		$GLOBALS['phpgw']->common = Factory::getInstance('common');
+		$GLOBALS['phpgw']->session = Factory::getInstance('sessions');
 		function lang($a){return $a;};
 
 		/* get the required configuration */
-		$BOEmailAdmin = $GLOBALS['workflow']['factory']->newForeignInstance('emailadmin', 'bo');
+		$BOEmailAdmin = Factory::getInstance('bo');
 		$profileList = $BOEmailAdmin->getProfileList();
 		$profile = $BOEmailAdmin->getProfile($profileList[0]['profileID']);
+
+		/**
+		 * XXX - XXX
+		 * It's weird.. There are two almost identical PHPMailer classes.
+		 * The class registered in our factory is under 'EGW_INC_ROOT'.
+		 * The class used here has the same name and it's under another
+		 * directory. For now, let's just include it in the old-fashion
+		 * way, but if someone, someday try to use both classes in the
+		 * same access, it could cause us troubles.
+		 */
 
 		/* configure the PHPMailer class to send the e-mails */
@@ -1494,6 +1499,6 @@
 	{
 		$output = array();
-		$cachedLDAP = &$GLOBALS['workflow']['factory']->getInstance('CachedLDAP');
-		$ldap = &$GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP');
+		$cachedLDAP = &Factory::getInstance('CachedLDAP');
+		$ldap = &Factory::getInstance('WorkflowLDAP');
 		foreach ($userIDs as $userID)
 		{
@@ -1542,5 +1547,5 @@
 	   	$filters[] = '(gia.wf_user IS NOT NULL)';
 
-		$cachedLDAP = &$GLOBALS['workflow']['factory']->newInstance('CachedLDAP');
+		$cachedLDAP = &Factory::newInstance('CachedLDAP');
 		$cachedLDAP->setOperationMode($cachedLDAP->OPERATION_MODE_LDAP);
 		$output = array();
@@ -1559,5 +1564,5 @@
 		}
 
-		$validUsers = $GLOBALS['workflow']['factory']->getInstance('WorkflowLDAP')->getNames(array_keys($userIDs));
+		$validUsers = Factory::getInstance('WorkflowLDAP')->getNames(array_keys($userIDs));
 		array_walk($validUsers, create_function('&$a', '$a = $a[\'id\'];'));
 
Index: sandbox/workflow/trunk/inc/class.ui_phpeditor.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.ui_phpeditor.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.ui_phpeditor.inc.php	(revision 2372)
@@ -11,5 +11,4 @@
 
 require_once dirname(__FILE__) . SEP . 'engine' . SEP . 'config.ajax.inc.php';
-require_once GALAXIA_LIBRARY . SEP . 'src' . SEP . 'ProcessManager' . SEP . 'ProcessManager.php';
 require_once dirname(__FILE__) . SEP . 'class.ui_ajaxinterface.inc.php';
 /**
@@ -45,5 +44,5 @@
 	function ui_phpeditor()
 	{
-		$this->bo = CreateObject('workflow.bo_editor');
+		$this->bo = Factory::getInstance('bo_editor');
 		$this->loadVariables();
 	}
@@ -62,6 +61,6 @@
 	function form()
 	{
-		$smarty = $GLOBALS['workflow']['factory']->getInstance('workflow_smarty', false);
-		$processManager = new ProcessManager($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+		$smarty = Factory::getInstance('workflow_smarty', false);
+		$processManager = &Factory::newInstance('ProcessManager');
 		$proccessInfo = $processManager->get_process($_GET['proc_id']);
 
Index: sandbox/workflow/trunk/inc/class.ResourcesRedirector.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.ResourcesRedirector.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.ResourcesRedirector.inc.php	(revision 2372)
@@ -54,5 +54,5 @@
 		if (!isset($_SESSION['workflow']['ResourcesRedirector'][$this->pid]))
 		{
-			$result = $GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID->query('SELECT wf_normalized_name FROM egw_wf_processes WHERE wf_p_id = ?', array($this->pid));
+			$result = Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID->query('SELECT wf_normalized_name FROM egw_wf_processes WHERE wf_p_id = ?', array($this->pid));
 			if ($result->numRows() != 1)
 				return;
@@ -94,5 +94,5 @@
 				{
 					/* em último caso, tenta buscar a informação em banco de dados */
-					$result = $GLOBALS['workflow']['workflowObjects']->getDBExpresso()->Link_ID->query('SELECT config_value FROM phpgw_config WHERE config_app = ? AND config_name = ?', array('phpgwapi', 'files_dir'));
+					$result = Factory::getInstance('WorkflowObjects')->getDBExpresso()->Link_ID->query('SELECT config_value FROM phpgw_config WHERE config_app = ? AND config_name = ?', array('phpgwapi', 'files_dir'));
 					if (empty($result))
 						return;
Index: sandbox/workflow/trunk/inc/hook_sidebox_menu.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/hook_sidebox_menu.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/hook_sidebox_menu.inc.php	(revision 2372)
@@ -14,8 +14,9 @@
  */
 
+require_once 'common.inc.php';
 require_once 'engine/config.egw.inc.php';
 
 {
-	$workflowACL = CreateObject('workflow.workflow_acl');
+	$workflowACL = Factory::getInstance('workflow_acl');
 	$userID = $GLOBALS['phpgw_info']['user']['account_id'];
 	$apptitle = $GLOBALS['phpgw_info']['apps'][$appname]['title'];
Index: sandbox/workflow/trunk/inc/class.workflow_wfsecurity.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.workflow_wfsecurity.inc.php	(revision 1712)
+++ sandbox/workflow/trunk/inc/class.workflow_wfsecurity.inc.php	(revision 2372)
@@ -18,5 +18,5 @@
 		function workflow_wfsecurity()
 		{
-			parent::WfSecurity($GLOBALS['workflow']['workflowObjects']->getDBGalaxia()->Link_ID);
+			parent::WfSecurity(Factory::getInstance('WorkflowObjects')->getDBGalaxia()->Link_ID);
 		}
 	}
Index: sandbox/workflow/trunk/inc/class.ui_agent_mail_smtp.inc.php
===================================================================
--- sandbox/workflow/trunk/inc/class.ui_agent_mail_smtp.inc.php	(revision 795)
+++ sandbox/workflow/trunk/inc/class.ui_agent_mail_smtp.inc.php	(revision 2372)
@@ -29,5 +29,5 @@
 		parent::ui_agent();
 		$this->agent_type = 'mail_smtp';
-		$this->bo_agent = CreateObject('workflow.bo_agent_mail_smtp');
+		$this->bo_agent = Factory::getInstance('bo_agent_mail_smtp');
 	}
 
